#include "bsp_adc.h"
#include "bsp_delay.h"
#include "bsp_led.h"

void BspAdcInit(void)
{
    //ʱӳʼ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA
                           |RCC_APB2Periph_ADC1	, ENABLE );	  //ʹADC1ͨʱ
    //GPIOʼ
    {
        GPIO_InitTypeDef GPIO_InitStructure;

        //PA1 Ϊģͨ
        GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;		//ģ
        GPIO_Init(GPIOA, &GPIO_InitStructure);
    }
    //ADC ʼ
    {
        ADC_InitTypeDef ADC_InitStructure;

        RCC_ADCCLKConfig(RCC_PCLK2_Div6);   //ADCƵ6 72M/6=12,ADCʱ䲻ܳ14M
        ADC_DeInit(ADC1);  //λADC1

        ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;	//ADCģʽ:ADC1ADC2ڶģʽ
        ADC_InitStructure.ADC_ScanConvMode = DISABLE;	//ģתڵͨģʽ
        ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;	//ģתڵתģʽ
        ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;	//תⲿ
        ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;	//ADCҶ
        ADC_InitStructure.ADC_NbrOfChannel = 1;	//˳йתADCͨĿ
        ADC_Init(ADC1, &ADC_InitStructure);	//ADC_InitStructָĲʼADCxļĴ

        ADC_Cmd(ADC1, ENABLE);	//ʹָADC1

        ADC_ResetCalibration(ADC1);	//ʹܸλУ׼

        while(ADC_GetResetCalibrationStatus(ADC1));	//ȴλУ׼

        ADC_StartCalibration(ADC1);	 //ADУ׼

        while(ADC_GetCalibrationStatus(ADC1));	 //ȴУ׼

        //	ADC_SoftwareStartConvCmd(ADC1, ENABLE);		//ʹָADC1ת
    }
}
//ADCֵ
//ch:ֵͨ 0~3
u16 GetAdc(u8 ch)
{
    //ָADCĹͨһУʱ
    ADC_RegularChannelConfig(ADC1, ch, 1, ADC_SampleTime_239Cycles5 );	//ADC1,ADCͨ,ʱΪ239.5

    ADC_SoftwareStartConvCmd(ADC1, ENABLE);		//ʹָADC1ת

    while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC ));//ȴת

    return ADC_GetConversionValue(ADC1);	//һADC1ת
}

u16 GetAdcAverage(u8 ch,u8 times)
{
    u32 temp_val=0;
    u8 t;
    for(t=0; t<times; t++)
    {
        temp_val+=GetAdc(ch);
        delay_ms(5);
    }
    return temp_val/times;
}

void AdcTest()
{
    u16 adcx;
    float temp;

    adcx=GetAdcAverage(ADC_Channel_1,10);
    temp=(float)adcx*(3.3/4096);
    if(adcx>3000||temp>2.5)
        led_on();
    else
        led_off();
}

