#include "bsp_exti.h"

#include "bsp_led.h"
#include "bsp_delay.h"

void EXTI0_IRQHandler(void)
{
    if(EXTI_GetITStatus(EXTI_Line0)!= RESET)
    {
        delay_ms(10);
        if(GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)==0)
        {
          
        }
        EXTI_ClearITPendingBit(EXTI_Line0);
    }
}

void BspExtiInit()
{
    //ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);
    //ųʼ
    {
        GPIO_InitTypeDef GPIO_InitStruct;

        GPIO_InitStruct.GPIO_Pin  = GPIO_Pin_0;
        GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IPU;

        GPIO_Init(GPIOA,&GPIO_InitStruct);
    }
    //ж߳ʼ
    {
        EXTI_InitTypeDef EXTI_InitStructure;

        EXTI_InitStructure.EXTI_Line    = EXTI_Line0;
        EXTI_InitStructure.EXTI_Mode    = EXTI_Mode_Interrupt;
        EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
        EXTI_InitStructure.EXTI_LineCmd = ENABLE;

        EXTI_Init(&EXTI_InitStructure);

        //ʼж
        GPIO_EXTILineConfig(GPIO_PortSourceGPIOA,GPIO_PinSource0);
    }
    //NVICʼ
    {
        NVIC_InitTypeDef NVIC_InitStructure;

        NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn;			//ʹⲿжͨ
        NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;	//ռȼ2
        NVIC_InitStructure.NVIC_IRQChannelSubPriority =        0;	//ȼ0
        NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;				//ʹⲿжͨ

        NVIC_Init(&NVIC_InitStructure);
    }
}
