#ifndef _LCD_H
#define _LCD_H

#include "main.h"

//-----------------LCD˿ڶ---------------- 
#define LCD_RCC_SCLK         RCC_APB2Periph_GPIOA
#define LCD_SCLK_GPIO        GPIOA
#define LCD_SCLK_GPIO_PIN    GPIO_Pin_0

#define LCD_RCC_MOSI         RCC_APB2Periph_GPIOA
#define LCD_MOSI_GPIO        GPIOA
#define LCD_MOSI_GPIO_PIN    GPIO_Pin_1

#define LCD_RCC_RES          RCC_APB2Periph_GPIOA
#define LCD_RES_GPIO         GPIOA
#define LCD_RES_GPIO_PIN     GPIO_Pin_2

#define LCD_RCC_DC           RCC_APB2Periph_GPIOA
#define LCD_DC_GPIO          GPIOA
#define LCD_DC_GPIO_PIN      GPIO_Pin_3

#define LCD_RCC_CS           RCC_APB2Periph_GPIOA
#define LCD_CS_GPIO          GPIOA
#define LCD_CS_GPIO_PIN      GPIO_Pin_4

#define LCD_RCC_BLK          RCC_APB2Periph_GPIOA
#define LCD_BLK_GPIO         GPIOA
#define LCD_BLK_GPIO_PIN     GPIO_Pin_5

void LCD_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color);//ָɫ
void LCD_DrawPoint(u16 x,u16 y,u16 color);//ָλûһ
void LCD_DrawLine(u16 x1,u16 y1,u16 x2,u16 y2,u16 color);//ָλûһ
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2,u16 color);//ָλûһ
void Draw_Circle(u16 x0,u16 y0,u8 r,u16 color);//ָλûһԲ

void LCD_ShowChinese(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾִ
void LCD_ShowChinese12x12(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾ12x12
void LCD_ShowChinese16x16(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾ16x16
void LCD_ShowChinese24x24(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾ24x24
void LCD_ShowChinese32x32(u16 x,u16 y,u8 *s,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾ32x32

void LCD_ShowChar(u16 x,u16 y,u8 num,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾһַ
void LCD_ShowString(u16 x,u16 y,const u8 *p,u16 fc,u16 bc,u8 sizey,u8 mode);//ʾַ
u32 mypow(u8 m,u8 n);//
void LCD_ShowIntNum(u16 x,u16 y,u16 num,u8 len,u16 fc,u16 bc,u8 sizey);//ʾ
void LCD_ShowFloatNum1(u16 x,u16 y,float num,u8 len,u16 fc,u16 bc,u8 sizey);//ʾλС

void LCD_ShowPicture(u16 x,u16 y,u16 length,u16 width,const u8 pic[]);//ʾͼƬ

//ɫ
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE           	 0x001F  
#define BRED             0XF81F
#define GRED 			 0XFFE0
#define GBLUE			 0X07FF
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
#define LIGHTGREEN     	 0X841F //ǳɫ
#define LGRAY 			 0XC618 //ǳɫ(PANNEL),屳ɫ
#define LGRAYBLUE        0XA651 //ǳɫ(мɫ)
#define LBBLUE           0X2B12 //ǳɫ(ѡĿķɫ)

#define USE_HORIZONTAL 2  //úʾ 01Ϊ 23Ϊ


#if USE_HORIZONTAL==0||USE_HORIZONTAL==1
#define LCD_W 135
#define LCD_H 240

#else
#define LCD_W 240
#define LCD_H 135
#endif

#define LCD_SCLK_Clr() GPIO_ResetBits(LCD_SCLK_GPIO,LCD_SCLK_GPIO_PIN)//SCL=SCLK
#define LCD_SCLK_Set() GPIO_SetBits(LCD_SCLK_GPIO,LCD_SCLK_GPIO_PIN)

#define LCD_MOSI_Clr() GPIO_ResetBits(LCD_MOSI_GPIO,LCD_MOSI_GPIO_PIN)//SDA=MOSI
#define LCD_MOSI_Set() GPIO_SetBits(LCD_MOSI_GPIO,LCD_MOSI_GPIO_PIN)

#define LCD_RES_Clr()  GPIO_ResetBits(LCD_RES_GPIO,LCD_RES_GPIO_PIN)//RES
#define LCD_RES_Set()  GPIO_SetBits(LCD_RES_GPIO,LCD_RES_GPIO_PIN)

#define LCD_DC_Clr()   GPIO_ResetBits(LCD_DC_GPIO,LCD_DC_GPIO_PIN)//DC
#define LCD_DC_Set()   GPIO_SetBits(LCD_DC_GPIO,LCD_DC_GPIO_PIN)
 		     
#define LCD_CS_Clr()   GPIO_ResetBits(LCD_CS_GPIO,LCD_CS_GPIO_PIN)//CS
#define LCD_CS_Set()   GPIO_SetBits(LCD_CS_GPIO,LCD_CS_GPIO_PIN)

#define LCD_BLK_Clr()  GPIO_ResetBits(LCD_BLK_GPIO,LCD_BLK_GPIO_PIN)//BLK
#define LCD_BLK_Set()  GPIO_SetBits(LCD_BLK_GPIO,LCD_BLK_GPIO_PIN)

void LCD_GPIO_Init(void);//ʼGPIO
void LCD_Writ_Bus(u8 dat);//ģSPIʱ
void LCD_WR_DATA8(u8 dat);//дһֽ
void LCD_WR_DATA(u16 dat);//дֽ
void LCD_WR_REG(u8 dat);//дһָ
void LCD_Address_Set(u16 x1,u16 y1,u16 x2,u16 y2);//꺯
void LCD_Init(void);//LCDʼ

#endif





